<?php
/**
 * @package		Wp2K2
 * @copyright	Copyright (C) 2005 - 2010 Syahril Zulkefli. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

class WP2K2Controller extends JController
{
	function display()
	{	
		$this->migrateTags();
		$this->migrateCategories();
		$this->migratePosts();
		$this->migrateComments();
	}

	function migrateTags()
	{
		$db =& JFactory::getDBO();

		$sql = "SELECT a.term_id, a.name FROM wp_terms AS a 
				LEFT JOIN wp_term_taxonomy AS b
				ON b.term_id = a.term_id
				WHERE b.taxonomy = 'post_tag'";
		
		$db->setQuery($sql);
		$items = $db->loadObjectList();
		
		echo '<h3>Migrating Tags from WordPress</h3>';
		
		foreach( $items as $item )
		{
			$sql = "INSERT INTO #__k2_tags(`id`, `name`, `published`) VALUES(".$db->Quote($item->term_id).", " . $db->Quote($item->name) . ", '1')";
			$db->setQuery($sql);
			
			if ( !$db->query() ) {
				echo '<span style="color: red;">Error</span> : <strong>' . $item->name . '</strong> cannot be migrated! <br /><pre>' . $db->stderr() . '</pre><hr />';
			}
			else {
				echo '<span style="color: green;">Success</span> : <strong>' . $item->name . '</strong> migrated!<br />';
			}
		}
		
		echo 'Done! ' . count($items) . ' items migrated!<hr />';
	}
	
	
	function migrateCategories()
	{
		$db =& JFactory::getDBO();
		
		$sql = "SELECT a.term_id, a.name, a.slug, b.parent FROM wp_terms AS a 
				LEFT JOIN wp_term_taxonomy AS b
				ON b.term_id = a.term_id
				WHERE b.taxonomy = 'category'";
		
		$db->setQuery($sql);
		$items = $db->loadObjectList();
		
		echo '<h3>Migrating Categories from WordPress</h3>';
		
		foreach( $items as $item )
		{
			//$sql = "INSERT INTO #__k2_categories(`name`, `published`, `wp_id`) VALUES(" . $db->Quote($tag->name) . ", '1', ".$db->Quote($tag->term_id).")";
			$sql = "INSERT INTO #__k2_categories(`id`, `name`,`alias`,`description`,`parent`,`extraFieldsGroup`,`published`,`access`,`ordering`,`image`,`params`,`trash`,`plugins`) 
					VALUES (".$db->Quote($item->term_id).", ".$db->Quote($item->name).",".$db->Quote($item->slug).",' ',".$db->Quote($item->parent).",'1','1','0','0',' ',".$db->Quote(getCategoryParams()).",'0',' ');";
			$db->setQuery($sql);
			
			if ( !$db->query() ) {
				echo '<span style="color: red;">Error</span> : <strong>' . $item->name . '</strong> cannot be migrated! <br /><pre>' . $db->stderr() . '</pre><hr />';
			}
			else {
				echo '<span style="color: green;">Success</span> : <strong>' . $item->name . '</strong> migrated!<br />';
			}
		}
		
		echo 'Done! ' . count($items) . ' items migrated!<hr />';
	}
	
	
	function migrateComments()
	{
		$db =& JFactory::getDBO();
		
		$sql = "SELECT * FROM wp_comments WHERE (comment_type != 'pingback' OR comment_type != 'trackback') AND comment_approved = '1' ORDER BY comment_ID ASC";
		$db->setQuery($sql);
		$items = $db->loadObjectList();
		
		echo '<h3>Migrating Comments from WordPress</h3>';
		
		foreach( $items as $item )
		{
			
			//echo '['.$item->comment_ID.'] - Original: ' . $item->comment_post_ID . ', New: ' . $this->getPostID( $item->comment_post_ID ) . '<br />';
			
			$sql = "INSERT INTO #__k2_comments(
						`id`,
						`itemID`,
						`userID`,
						`userName`,
						`commentDate`,
						`commentText`,
						`commentEmail`,
						`commentURL`,
						`published`
					) 
					VALUES ( 
						".$db->Quote($item->comment_ID).",
						".$db->Quote($item->comment_post_ID).",
						".$db->Quote('0').",
						".$db->Quote($item->comment_author).",
						".$db->Quote($item->comment_date_gmt).",
						".$db->Quote($item->comment_content).",
						".$db->Quote($item->comment_author_email).",
						".$db->Quote($item->comment_author_url).",
						'1'
					);";
			
			$db->setQuery($sql);
			
			if ( !$db->query() ) {
				echo '<span style="color: red;">Error</span> : <strong>' . $item->comment_ID . '</strong> cannot be migrated! <br /><pre>' . $db->stderr() . '</pre><hr />';
			}
			else {
				//echo '<span style="color: green;">Success</span> : <strong>' . $item->name . '</strong> migrated!<br />';
			}
			$i++;
		}
		echo 'Done! ' . count($items) . ' items migrated!<hr />';
	}
	
	function migratePosts()
	{
		$db =& JFactory::getDBO();
		
		$sql = "SELECT * FROM wp_posts WHERE (post_type = 'post' AND post_status != 'auto-draft' AND post_status != 'draft')";
		$db->setQuery($sql);
		$items = $db->loadObjectList();
		
		$i = 1;
		
		echo '<h3>Migrating Posts from WordPress</h3>';
		
		foreach( $items as $item )
		{
			$content = $item->post_content;
			
			// replace <!--more--> with <hr id="system-readmore" />
			$content = str_replace("<!--more-->", "<hr id=\"system-readmore\" />", $content);
						
			// replace &nbsp; to space
			$content = str_replace("&nbsp;", " ", $content);
			
			// replace multiple spaces to single space
			$content = str_replace("  "	, " ", $content);
			$content = str_replace("   ", " ", $content);
			
			// split both intrtext and fulltext
		    $pattern = '#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i';
		    $tagPos = preg_match($pattern, $content);
		    if ($tagPos == 0) {
		        $introtext = $content;
		        $fulltext = '';
		    } 
			else {
		    	list($introtext, $fulltext) = preg_split($pattern, $content, 2);
		    }			
		    
		    // WordPress auto-formatting
			$introtext 	= wpautop($introtext);
			$fulltext 	= wpautop($fulltext);

		    $sql2 = "INSERT INTO #__k2_items(
		    			`id`,
						`title`,
						`alias`,
						`catid`,
						`published`,
						`introtext`,
						`fulltext`,
						`video`,
						`gallery`,
						`extra_fields`,
						`extra_fields_search`,
						`created`,
						`created_by`,
						`created_by_alias`,
						`checked_out`,
						`checked_out_time`,
						`modified`,
						`modified_by`,
						`publish_up`,
						`publish_down`,
						`trash`,
						`access`,
						`ordering`,
						`featured`,
						`featured_ordering`,
						`image_caption`,
						`image_credits`,
						`video_caption`,
						`video_credits`,
						`hits`,
						`params`,
						`metadesc`,
						`metadata`,
						`metakey`,
						`plugins`
					) " . 
					"VALUES ( 
						".$db->Quote($item->ID).",
						".$db->Quote($item->post_title).",
						".$db->Quote($item->post_name).",
						".$db->Quote($this->getCategory($item->ID)).",
						'1',
						".$db->Quote($introtext).",
						".$db->Quote($fulltext).",
						' ',
						' ',
						'[]',
						' ',
						'".$item->post_date_gmt."',
						'62',
						' ',
						'0',
						'0000-00-00 00:00:00',
						'".$item->post_modified_gmt."',
						'0',
						'".$item->post_date_gmt."',
						'0000-00-00 00:00:00',
						'0',
						'0',
						'1',
						'0',
						'0',
						' ',
						' ',
						' ',
						' ',
						'0',
						".$db->Quote(getParams()).",
						' ',
						' ',
						' ',
						' '
					);";
		    

	    	$db->setQuery($sql2);

			if ( !$db->query() ) {
				echo '<span style="color: red;">Error</span> : <strong>' . $item->post_title . '</strong> cannot be migrated! <br /><pre>' . $db->stderr() . '</pre><hr />';
			}
			else {
				echo '<span style="color: green;">Success</span> : <strong>' . $item->post_title . '</strong> migrated!<br />';
				
				// get all post tags
				$this->migratePostsTags($item->ID);
			}
			$i++;
		}	
		echo 'Done! ' . count($items) . ' items migrated!<hr />';
	}
	
	
	function getCategory( $id )
	{
		$db =& JFactory::getDBO();
		
		$sql = "
		SELECT a.term_taxonomy_id AS id, b.term_id FROM wp_term_relationships as a
		left join wp_term_taxonomy as b
		on b.term_taxonomy_id = a.term_taxonomy_id
		left join wp_terms as c
		on c.term_id = b.term_id
		WHERE 
			b.taxonomy = 'category'
		AND
			a.object_id = ".$db->Quote($id)." 
		limit 1";
		
		$db->setQuery($sql);
		$item = $db->loadObject();
		
		return $item->term_id;		
	}


	function migratePostsTags( $id )
	{
		$db =& JFactory::getDBO();

		$sql = "
		SELECT a.term_taxonomy_id AS id, b.term_id FROM wp_term_relationships as a
		left join wp_term_taxonomy as b
		on b.term_taxonomy_id = a.term_taxonomy_id
		left join wp_terms as c
		on c.term_id = b.term_id
		WHERE 
			b.taxonomy = 'post_tag'
		AND
			a.object_id = ".$db->Quote($id);
		
		$db->setQuery($sql);
		$items = $db->loadObjectList();
		
		foreach( $items as $item ) {
			$sql = "INSERT INTO #__k2_tags_xref(`tagID`, `itemID`) VALUES(".$db->Quote($item->term_id).",".$db->Quote($id).")";
			$db->setQuery($sql);
			$db->query();
		}

	}	
	
}