<?php
/**
 * @package		Wp2K2
 * @copyright	Copyright (C) 2005 - 2010 Syahril Zulkefli. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );


/**
 * Replace double line breaks to <p></p> elements
 * 
 * - borrowed from WordPress function  
 */ 
function wpautop($pee, $br = 1) {

	if ( trim($pee) === '' )
		return '';
		
	$pee = $pee . "\n"; // just to make things a little easier, pad the end
	$pee = preg_replace('|<br />\s*<br />|', "\n\n", $pee);
	
	// Space things out a little
	$allblocks = '(?:table|thead|tfoot|caption|col|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|option|form|map|area|blockquote|address|math|style|input|p|h[1-6]|hr|fieldset|legend|section|article|aside|hgroup|header|footer|nav|figure|figcaption|details|menu|summary)';
	$pee = preg_replace('!(<' . $allblocks . '[^>]*>)!', "\n$1", $pee);
	$pee = preg_replace('!(</' . $allblocks . '>)!', "$1\n\n", $pee);
	$pee = str_replace(array("\r\n", "\r"), "\n", $pee); // cross-platform newlines
	
	if ( strpos($pee, '<object') !== false ) {
		$pee = preg_replace('|\s*<param([^>]*)>\s*|', "<param$1>", $pee); // no pee inside object/embed
		$pee = preg_replace('|\s*</embed>\s*|', '</embed>', $pee);
	}
	
	$pee = preg_replace("/\n\n+/", "\n\n", $pee); // take care of duplicates
	
	// make paragraphs, including one at the end
	$pees = preg_split('/\n\s*\n/', $pee, -1, PREG_SPLIT_NO_EMPTY);
	$pee = '';
	
	foreach ( $pees as $tinkle )
		$pee .= '<p>' . trim($tinkle, "\n") . "</p>\n";
		
	$pee = preg_replace('|<p>\s*</p>|', '', $pee); // under certain strange conditions it could create a P of entirely whitespace
	$pee = preg_replace('!<p>([^<]+)</(div|address|form)>!', "<p>$1</p></$2>", $pee);
	$pee = preg_replace('!<p>\s*(</?' . $allblocks . '[^>]*>)\s*</p>!', "$1", $pee); // don't pee all over a tag
	$pee = preg_replace("|<p>(<li.+?)</p>|", "$1", $pee); // problem with nested lists
	$pee = preg_replace('|<p><blockquote([^>]*)>|i', "<blockquote$1><p>", $pee);
	$pee = str_replace('</blockquote></p>', '</p></blockquote>', $pee);
	$pee = preg_replace('!<p>\s*(</?' . $allblocks . '[^>]*>)!', "$1", $pee);
	$pee = preg_replace('!(</?' . $allblocks . '[^>]*>)\s*</p>!', "$1", $pee);
	
	if ($br) {
		$pee = preg_replace_callback('/<(script|style).*?<\/\\1>/s', create_function('$matches', 'return str_replace("\n", "<WPPreserveNewline />", $matches[0]);'), $pee);
		$pee = preg_replace('|(?<!<br />)\s*\n|', "<br />\n", $pee); // optionally make line breaks
		$pee = str_replace('<WPPreserveNewline />', "\n", $pee);
	}
	
	$pee = preg_replace('!(</?' . $allblocks . '[^>]*>)\s*<br />!', "$1", $pee);
	$pee = preg_replace('!<br />(\s*</?(?:p|li|div|dl|dd|dt|th|pre|td|ul|ol)[^>]*>)!', '$1', $pee);
	if (strpos($pee, '<pre') !== false)
		$pee = preg_replace_callback('!(<pre[^>]*>)(.*?)</pre>!is', 'clean_pre', $pee );
		
	$pee = preg_replace( "|\n</p>$|", '</p>', $pee );

	return $pee;
}


function getParams()
{
	$params = "catItemTitle=\n
catItemTitleLinked=\n
catItemFeaturedNotice=\n
catItemAuthor=\n
catItemDateCreated=\n
catItemRating=\n
catItemImage=\n
catItemIntroText=\n
catItemExtraFields=\n
catItemHits=\n
catItemCategory=\n
catItemTags=\n
catItemAttachments=\n
catItemAttachmentsCounter=\n
catItemVideo=\n
catItemVideoWidth=\n
catItemVideoHeight=\n
catItemVideoAutoPlay=\n
catItemImageGallery=\n
catItemDateModified=\n
catItemReadMore=\n
catItemCommentsAnchor=\n
catItemK2Plugins=\n
itemDateCreated=\n
itemTitle=\n
itemFeaturedNotice=\n
itemAuthor=\n
itemFontResizer=\n
itemPrintButton=\n
itemEmailButton=\n
itemSocialButton=\n
itemVideoAnchor=\n
itemImageGalleryAnchor=\n
itemCommentsAnchor=\n
itemRating=\n
itemImage=\n
itemImgSize=\n
itemImageMainCaption=\n
itemImageMainCredits=\n
itemIntroText=\n
itemFullText=\n
itemExtraFields=\n
itemDateModified=\n
itemHits=\n
itemTwitterLink=\n
itemCategory=\n
itemTags=\n
itemShareLinks=\n
itemAttachments=\n
itemAttachmentsCounter=\n
itemRelated=\n
itemRelatedLimit=\n
itemVideo=\n
itemVideoWidth=\n
itemVideoHeight=\n
itemVideoAutoPlay=\n
itemVideoCaption=\n
itemVideoCredits=\n
itemImageGallery=\n
itemNavigation=\n
itemComments=\n
itemAuthorBlock=\n
itemAuthorImage=\n
itemAuthorDescription=\n
itemAuthorURL=\n
itemAuthorEmail=\n
itemAuthorLatest=\n
itemAuthorLatestLimit=\n
itemK2Plugins=\n";
	
	return $params;
}


function getCategoryParams()
{
	$params = "
inheritFrom=0\n
theme=\n
num_leading_items=2\n
num_leading_columns=1\n
leadingImgSize=Large\n
num_primary_items=4\n
num_primary_columns=2\n
primaryImgSize=Medium\n
num_secondary_items=4\n
num_secondary_columns=1\n
secondaryImgSize=Small\n
num_links=4\n
num_links_columns=1\n
linksImgSize=XSmall\n
catCatalogMode=0\n
catFeaturedItems=1\n
catOrdering=\n
catPagination=2\n
catPaginationResults=1\n
catTitle=1\n
catTitleItemCounter=1\n
catDescription=1\n
catImage=1\n
catFeedLink=1\n
feedLink=1\n
subCategories=1\n
subCatColumns=2\n
subCatOrdering=\n
subCatTitle=1\n
subCatTitleItemCounter=1\n
subCatDescription=1\n
subCatImage=1\n
itemImageXS=\n
itemImageS=\n
itemImageM=\n
itemImageL=\n
itemImageXL=\n
catItemTitle=1\n
catItemTitleLinked=1\n
catItemFeaturedNotice=0\n
catItemAuthor=1\n
catItemDateCreated=1\n
catItemRating=0\n
catItemImage=1\n
catItemIntroText=1\n
catItemIntroTextWordLimit=\n
catItemExtraFields=0\n
catItemHits=0\n
catItemCategory=1\n
catItemTags=1\n
catItemAttachments=0\n
catItemAttachmentsCounter=0\n
catItemVideo=0\n
catItemVideoWidth=\n
catItemVideoHeight=\n
catItemVideoAutoPlay=0\n
catItemImageGallery=0\n
catItemDateModified=0\n
catItemReadMore=1\n
catItemCommentsAnchor=1\n
catItemK2Plugins=1\n
itemDateCreated=1\n
itemTitle=1\n
itemFeaturedNotice=1\n
itemAuthor=1\n
itemFontResizer=1\n
itemPrintButton=1\n
itemEmailButton=1\n
itemSocialButton=1\n
itemVideoAnchor=1\n
itemImageGalleryAnchor=1\n
itemCommentsAnchor=1\n
itemRating=1\n
itemImage=1\n
itemImgSize=Large\n
itemImageMainCaption=1\n
itemImageMainCredits=1\n
itemIntroText=1\n
itemFullText=1\n
itemExtraFields=1\n
itemDateModified=1\n
itemHits=1\n
itemTwitterLink=1\n
itemCategory=1\n
itemTags=1\n
itemShareLinks=1\n
itemAttachments=1\n
itemAttachmentsCounter=1\n
itemRelated=1\n
itemRelatedLimit=5\n
itemVideo=1\n
itemVideoWidth=\n
itemVideoHeight=\n
itemVideoAutoPlay=0\n
itemVideoCaption=1\n
itemVideoCredits=1\n
itemImageGallery=1\n
itemNavigation=1\n
itemComments=1\n
itemAuthorBlock=1\n
itemAuthorImage=1\n
itemAuthorDescription=1\n
itemAuthorURL=1\n
itemAuthorEmail=0\n
itemAuthorLatest=1\n
itemAuthorLatestLimit=5\n
itemK2Plugins=1\n";
	
	return $params;
}
